<ng-container *ngIf="{
          ghostElements: ghostElements$ | async,
          screenSize: screenSize$ | async,
          educatorPage: dataPage$ | async,
          clubs: clubs$ | async,
          categories: categories$ | async,
          participants: participants$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.educator.list.seo.title' | translate }}
      </h1>
      <p>
        {{ 'admin.educator.list.seo.description' | translate }}
      </p>

      <form [formGroup]="formGroup">
        <form [formGroup]="asFormGroup(formGroup.controls.raw)">
          <mat-form-field>
            <mat-label>
              {{ 'admin.educator.list.filter.clubs' | translate }}
            </mat-label>
            <app-reset-button-icon matPrefix
                                   [display]="!!formGroup.getRawValue().raw?.clubs"
                                   (resetClick)="clubsChange(undefined)">
            </app-reset-button-icon>
            <app-async-select [loading]="loading.clubs"
                              [control]="asFormGroup(formGroup.controls.raw).controls.clubs"
                              [updateDisable]="false">
              <mat-select formControlName="clubs" multiple
                          (selectionChange)="clubsChange($event.value)">
                <mat-option *ngFor="let club of vm.clubs?.items; trackBy: trackBySlug"
                            [value]="club.slug" class="team">
                  <figure *ngIf="'common.team.defaultPicture.url' | translate">
                    <img class="lazy-load"
                         [lazyLoad]="club.logoUrl || ('common.team.defaultPicture.url' | translate)"
                         [errorImage]="'common.team.defaultPicture.url' | translate"
                         [alt]="club.name" />
                    <figcaption>
                      {{ club | teamName:vm.screenSize }}
                    </figcaption>
                  </figure>
                </mat-option>
              </mat-select>
            </app-async-select>
          </mat-form-field>
        </form>

        <div class="or">
          <span>OU</span>
        </div>


        <form [formGroup]="asFormGroup(formGroup.controls.competition)">
          <mat-form-field>
            <mat-label>
              {{ 'admin.educator.list.filter.categories' | translate }}
            </mat-label>
            <app-reset-button-icon matPrefix
                                   [display]="!!formGroup.getRawValue().competition?.categories"
                                   (resetClick)="categoriesChange(undefined)">
            </app-reset-button-icon>
            <app-async-select [loading]="loading.categories"
                              [control]="asFormGroup(formGroup.controls.competition).controls.categories"
                              [updateDisable]="false">
              <mat-select formControlName="categories" multiple
                          (selectionChange)="categoriesChange($event.value)">
                <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                            [value]="category.slug">
                  {{ category.name }}
                </mat-option>
              </mat-select>
            </app-async-select>
          </mat-form-field>

          <mat-form-field>
            <mat-label>
              {{ 'admin.educator.list.filter.participants' | translate }}
            </mat-label>
            <app-reset-button-icon matPrefix
                                   [display]="!!formGroup.getRawValue().competition?.participants"
                                   (resetClick)="participantsChange(undefined)">
            </app-reset-button-icon>
            <app-async-select [loading]="loading.participants"
                              [control]="asFormGroup(formGroup.controls.competition).controls.participants"
                              [updateDisable]="false">
              <mat-select formControlName="participants" multiple
                          (selectionChange)="participantsChange($event.value)">
                <mat-option *ngFor="let participant of vm.participants?.items; trackBy: trackBySlug"
                            [value]="participant.slug" class="team">
                  <figure *ngIf="'common.team.defaultPicture.url' | translate">
                    <img class="lazy-load"
                         [lazyLoad]="participant.logoUrl || ('common.team.defaultPicture.url' | translate)"
                         [errorImage]="'common.team.defaultPicture.url' | translate"
                         [alt]="participant.name" />
                    <figcaption>
                      {{ participant | teamName:vm.screenSize }}
                    </figcaption>
                  </figure>
                </mat-option>
              </mat-select>
            </app-async-select>
          </mat-form-field>
        </form>
      </form>

      <section>
        <div class="table-wrapper">
          <table mat-table [dataSource]="loading.list ? vm.ghostElements : vm.educatorPage?.items"
                 [trackBy]="trackBySlug"
                 matSort matSortDisableClear
                 (matSortChange)="sort($event)"
                 [matSortActive]="vm.educatorPage?.sort?.field || 'lastName'"
                 [matSortDirection]="vm.educatorPage?.sort?.direction || 'asc'">

            <ng-container matColumnDef="firstName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.educator.list.field.firstName' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.firstName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="lastName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.educator.list.field.lastName' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.lastName }}
              </td>
            </ng-container>

            <ng-container matColumnDef="code">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.educator.list.field.code' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.code | licenseNumber }}
              </td>
            </ng-container>

            <ng-container matColumnDef="clubName">
              <th mat-header-cell *matHeaderCellDef mat-sort-header
                  class="logo">
                {{ 'admin.educator.list.field.club' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <figure>
                  <img class="lazy-load"
                       *ngIf="'common.team.defaultPicture.url' | translate"
                       [lazyLoad]="element.clubLogoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="element.clubName"
                       [matTooltip]="element.clubName" />
                </figure>
              </td>
            </ng-container>

            <ng-container matColumnDef="action">
              <th mat-header-cell *matHeaderCellDef></th>
              <td mat-cell *matCellDef="let element"
                  class="actions">
                <a mat-icon-button
                   [routerLink]="[element.slug, 'update']"
                   [attr.aria-label]="'admin.common.action.update' | translate"
                   [matTooltip]="'admin.common.action.update' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    edit
                  </mat-icon>
                </a>
                <a mat-icon-button
                   [routerLink]="[element.slug, 'duplicate']"
                   [attr.aria-label]="'admin.common.action.duplicate' | translate"
                   [matTooltip]="'admin.common.action.duplicate' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    filter_none
                  </mat-icon>
                </a>
                <button mat-icon-button
                        (click)="delete(element)"
                        [attr.aria-label]="'admin.common.action.delete' | translate"
                        [matTooltip]="'admin.common.action.delete' | translate"
                        matTooltipPosition="left">
                  <mat-icon>
                    delete
                  </mat-icon>
                </button>
              </td>
            </ng-container>

            <ng-container *ngFor="let ghostColumn of ghostColumns">
              <ng-container [matColumnDef]="ghostColumn">
                <td mat-cell *matCellDef class="ghost"><div></div></td>
              </ng-container>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="columns; sticky: true"></tr>
            <ng-container *ngIf="loading.list then ghost; else data"></ng-container>
            <ng-template #data>
              <tr mat-row *matRowDef="let row; columns: columns;"></tr>
            </ng-template>
            <ng-template #ghost>
              <tr mat-row *matRowDef="let row; columns: ghostColumns;"></tr>
            </ng-template>
          </table>
        </div>
        <mat-paginator [length]="vm.educatorPage?.count"
                       [pageIndex]="vm.educatorPage?.page"
                       [pageSize]="vm.educatorPage?.size"
                       [pageSizeOptions]="pageSizes"
                       (page)="goToPage($event)">
        </mat-paginator>
      </section>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-flat-button color="primary"
         [routerLink]="['create']"
         [queryParams]="formGroup.value.raw?.clubs?.length ? { club: formGroup.value.raw.clubs[0] } : undefined">
        <mat-icon>
          add
        </mat-icon>
        {{ 'admin.common.action.create' | translate }}
      </a>
    </ng-container>
  </app-page-form>
</ng-container>
